/* ToolTraps */
/*
Programmed by Alexander M Kasprzyk, 1997

A set of useful trap calls for 68K Macs only

alex@kasprzyk.demon.co.uk
*/

#ifndef _ToolTrapsPr_
#define _ToolTrapsPr_

#ifndef powerc

#include <QDOffscreen.h>

#ifdef _main_tooltraps_
#define LIMIT /*GLOBAL*/
#else
#define LIMIT extern
#endif

typedef pascal void			(*CopyBitsPtr)( const BitMap *, const BitMap *, const Rect *, const Rect *, short, RgnHandle );
typedef pascal unsigned long	(*TickCountPtr)( void );
typedef pascal short			(*RandomPtr)( void );
typedef pascal void			(*EraseRectPtr)( const Rect * );
typedef pascal void			(*ClipRectPtr)( const Rect * );
typedef pascal void			(*MoveToPtr)( short, short );
typedef pascal void			(*DrawStringPtr)( ConstStr255Param );
typedef pascal void			(*FrameRectPtr)( const Rect * );
typedef pascal Boolean		(*ButtonPtr)( void );

LIMIT	CopyBitsPtr		copyBitsAddress;
LIMIT	TickCountPtr		tickCountAddress;
LIMIT	RandomPtr		randomAddress;
LIMIT	EraseRectPtr		eraseRectAddress;
LIMIT	ClipRectPtr		clipRectAddress;
LIMIT	MoveToPtr		moveToAddress;
LIMIT	DrawStringPtr		drawStringAddress;
LIMIT	FrameRectPtr		frameRectAddress;
LIMIT	ButtonPtr			buttonAddress;

#define	MCopyBits( bs, bd, rs, rd, sh, rg )		(*copyBitsAddress)( bs, bd, rs, rd, sh, rg )
#define	MTickCount()						(*tickCountAddress)()
#define	MRandom()						(*randomAddress)()
#define	MEraseRect( rt )					(*eraseRectAddress)( rt )
#define	MClipRect( rt )						(*clipRectAddress)( rt )
#define	MMoveTo( h, v )					(*moveToAddress)( h, v )
#define	MDrawString( st )					(*drawStringAddress)( st )
#define	MFrameRect( rt )					(*frameRectAddress)( rt )
#define	MButton()							(*buttonAddress)()

void		GetCommonTraps	( void );

#undef _main_tooltraps_

#else

#define	MCopyBits( bs, bd, rs, rd, sh, rg )		CopyBits( bs, bd, rs, rd, sh, rg )
#define	MTickCount()						TickCount()
#define	MRandom()						Random()
#define	MEraseRect( rt )					EraseRect( rt )
#define	MClipRect( rt )						ClipRect( rt )
#define	MMoveTo( h, v )					MoveTo( h, v )
#define	MDrawString( st )					DrawString( st )
#define	MFrameRect( rt )					FrameRect( rt )
#define	MButton()							Button()

#endif
#endif